PROGRAM MIMOSIS

    !Modules to use    
    USE MIMOSIS_DATA
    USE MIMOSIS_SUBROUTINES     

    !Declaration statement
    IMPLICIT NONE    
    INTEGER,DIMENSION(19,7)                        ::  ITIME                             !Matrix to store different time elements
    INTEGER                                        ::  I,ierror
    CHARACTER(len=30),DIMENSION(18)                ::  ROUTNAME
    REAL,DIMENSION(19)                             ::  SECUSED                           !Vector to store the seconds used for each call 
    INTEGER                                        ::  COUNCALL                          !Counter to store the number of executed calls 
    
    !Define routine names for later use in time registration application
    ROUTNAME(1)     = 'MIMOSIS_PARAM'
    ROUTNAME(2)     = 'WORKHOUR_FILEREAD'
    ROUTNAME(3)     = 'FAMREL'
    ROUTNAME(4)     = 'PENSWELF_PRERUN'
    ROUTNAME(5)     = 'FAMAL_PRERUN'
    ROUTNAME(6)     = 'CONTRIB_PRERUN'
    ROUTNAME(7)     = 'PIT_PRERUN'
    ROUTNAME(8)     = 'SICK_PRERUN'
    ROUTNAME(9)     = 'UNEM_PRERUN'
    ROUTNAME(10)    = 'SOCBEN_PRERUN'
    ROUTNAME(11)    = 'PENSWELF'
    ROUTNAME(12)    = 'FAMAL'
    ROUTNAME(13)    = 'SICK'
    ROUTNAME(14)    = 'UNEM'
    ROUTNAME(15)    = 'CONTRIB'
    ROUTNAME(16)    = 'PIT'
    ROUTNAME(17)    = 'SOCBEN' 
    ROUTNAME(18)    = 'EVAL'    
    
    !Call MIMOSIS_START 
    CALL MIMOSIS_START
    
    !Clear log file of simulation run
    OPEN (UNIT=15, FILE=MIMOSIS_RUN_LOG, ACTION='WRITE', IOSTAT=ierror)
    CLOSE(15)
!If info should be appended, use following lines    
!    OPEN (UNIT=15, FILE=MIMOSIS_RUN_LOG, POSITION='APPEND', ACTION='WRITE', IOSTAT=ierror)
!    CLOSE(15)

    !Start a pre run simulation if necessary
    IF (CONTROL_TYPESIM(1).EQ.'yes') THEN
        WRITE(*,*) 'You start to simulate a PRE reform situation'
        CONTROL = CONTROL_TYPESIM(1)
        MIMOSIS_PARLOC = MIMOSIS_PARLPRE

        COUNCALL = 1
        !Register start time and call first routine
        call X05AAF(ITIME(COUNCALL,:))
        CALL MIMOSIS_PARAM
        !call routine to read workhours 
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL WORKHOUR_FILEREAD
        !call routine to read workhours 
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL FAMREL
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL PENSWELF_PRERUN
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL FAMAL_PRERUN
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL CONTRIB_PRERUN
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL PIT_PRERUN  
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL SICK_PRERUN  
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL UNEM_PRERUN    
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL SOCBEN_PRERUN    
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL PENSWELF
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL FAMAL
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL SICK
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL UNEM
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL CONTRIB
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL PIT
        !Register time and call routine
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL SOCBEN
        !Register stop time 
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))

        !Compute the seconds that correspond with each time registration
        DO i=1,COUNCALL
            SECUSED(i) = ITIME(i,4)*3600.D0+ITIME(i,5)*60+ITIME(i,6)+ITIME(i,7)/100
        END DO

        !open log file       
        OPEN (UNIT=15, FILE=MIMOSIS_RUN_LOG, POSITION='APPEND', ACTION='WRITE', IOSTAT=ierror)
        !write execution time
        WRITE(15,'(1x,''The pre reform started                                  '',&
        &'' at registered time: '',i2,'' h '',i2,'' min '',i2,''.'',i2,'' sec'')')&
        &ITIME(1,4),ITIME(1,5),ITIME(1,6),ITIME(1,7)
        DO i=2,COUNCALL
            WRITE(15,'(1x,''Execution of CALL '',a30,&
            &''finished at registered time: '',i2,'' h '',i2,'' min '',i2,''.'',i2,'' sec and thus used'',&
            &F15.2,'' second(s)'')')&
            &ROUTNAME(i-1),ITIME(i,4),ITIME(i,5),ITIME(i,6),ITIME(i,7),SECUSED(i)-SECUSED(i-1)
        END DO
        WRITE(15,'(1x,''Execution of CALL '',a30,''was the last operation performed by the pre reform'')')ROUTNAME(COUNCALL-1)    
        CLOSE(15)
    END IF

    !Start a post run simulation if necessary
    IF (CONTROL_TYPESIM(2).EQ.'yes') THEN
        IF (CONTROL_TYPESIM(1).EQ.'yes') THEN
            WRITE(*,*) ' '
        END IF
        WRITE(*,*) 'You start to simulate a POST reform situation'
        CONTROL = CONTROL_TYPESIM(2)
        MIMOSIS_PARLOC = MIMOSIS_PARLPOST

        COUNCALL = 1
        !Register start time and call first routine
        call X05AAF(ITIME(COUNCALL,:))
        CALL MIMOSIS_PARAM
        !call routine to read workhours 
        COUNCALL = COUNCALL + 1        
        call X05AAF(ITIME(COUNCALL,:))
        CALL WORKHOUR_FILEREAD
        !call routine to read workhours 
        COUNCALL = COUNCALL + 1
        call X05AAF(ITIME(COUNCALL,:))
        CALL FAMREL
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL PENSWELF_PRERUN
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL FAMAL_PRERUN
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL CONTRIB_PRERUN
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL PIT_PRERUN  
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL SICK_PRERUN  
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL UNEM_PRERUN    
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL SOCBEN_PRERUN    
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL PENSWELF
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL FAMAL
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL SICK
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL UNEM
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL CONTRIB
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL PIT
        !Register time and call routine
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))
        CALL SOCBEN
        !Register stop time 
        COUNCALL = COUNCALL + 1   
        call X05AAF(ITIME(COUNCALL,:))

        !Compute the seconds that correspond with each time registration
        DO i=1,COUNCALL
            SECUSED(i) = ITIME(i,4)*3600.D0+ITIME(i,5)*60+ITIME(i,6)+ITIME(i,7)/100
        END DO

        !open log file       
        OPEN (UNIT=15, FILE=MIMOSIS_RUN_LOG, POSITION='APPEND', ACTION='WRITE', IOSTAT=ierror)
        IF (CONTROL_TYPESIM(1).EQ.'yes') THEN
            WRITE(15,*) ' '
        END IF
        !write execution time
        WRITE(15,'(1x,''The post reform started                                 '',&
        &'' at registered time: '',i2,'' h '',i2,'' min '',i2,''.'',i2,'' sec'')')&
        &ITIME(1,4),ITIME(1,5),ITIME(1,6),ITIME(1,7)
        DO i=2,COUNCALL
            WRITE(15,'(1x,''Execution of CALL '',a30,&
            &''finished at registered time: '',i2,'' h '',i2,'' min '',i2,''.'',i2,'' sec and thus used'',&
            &F15.2,'' second(s)'')')&
            &ROUTNAME(i-1),ITIME(i,4),ITIME(i,5),ITIME(i,6),ITIME(i,7),SECUSED(i)-SECUSED(i-1)
        END DO
        WRITE(15,'(1x,''Execution of CALL '',a30,''was the last operation performed by the post reform'')')ROUTNAME(COUNCALL-1)    
        CLOSE(15)
    END IF

    !Start a pre run simulation if necessary
    IF (CONTROL_TYPESIM(3).EQ.'yes') THEN
        IF (CONTROL_TYPESIM(1).EQ.'yes'.OR.CONTROL_TYPESIM(2).EQ.'yes') THEN
            WRITE(*,*) ' '
        END IF
        !register starting time if only an evaluation is carried out
        IF (CONTROL_TYPESIM(1).NE.'yes'.AND.CONTROL_TYPESIM(2).NE.'yes') THEN        
            call X05AAF(ITIME(COUNCALL,:))
        END IF    
        !call eval 
        CALL EVAL
        !Register stop time after EVAL has been executed
        COUNCALL = COUNCALL + 1  
        call X05AAF(ITIME(COUNCALL,:))

        !Compute the seconds that correspond with each time registration
        DO i=COUNCALL-1,COUNCALL
            SECUSED(i) = ITIME(i,4)*3600.D0+ITIME(i,5)*60+ITIME(i,6)+ITIME(i,7)/100
        END DO

        !open log file       
        OPEN (UNIT=15, FILE=MIMOSIS_RUN_LOG, POSITION='APPEND', ACTION='WRITE', IOSTAT=ierror)
        IF (CONTROL_TYPESIM(1).EQ.'yes'.OR.CONTROL_TYPESIM(2).EQ.'yes') THEN
            WRITE(15,*) ' '
        END IF
        !write execution time
        WRITE(15,'(1x,''The evaluation started                                  '',&
        &'' at registered time: '',i2,'' h '',i2,'' min '',i2,''.'',i2,'' sec'')')&
        &ITIME(COUNCALL-1,4),ITIME(COUNCALL-1,5),ITIME(COUNCALL-1,6),ITIME(COUNCALL-1,7)
        DO i=COUNCALL,COUNCALL
            WRITE(15,'(1x,''Execution of CALL '',a30,&
            &''finished at registered time: '',i2,'' h '',i2,'' min '',i2,''.'',i2,'' sec and thus used'',&
            &F15.2,'' second(s)'')')&
            &ROUTNAME(i-1),ITIME(i,4),ITIME(i,5),ITIME(i,6),ITIME(i,7),SECUSED(i)-SECUSED(i-1)
        END DO
        WRITE(15,'(1x,''Execution of CALL '',a30,''was the last operation performed'')')ROUTNAME(COUNCALL-1)    
        CLOSE(15)
    END IF

    STOP
    
END PROGRAM MIMOSIS
